# Makefile for kermit using Desktop C.
# Risc_OSLib is necessary for mode() and vdu() functions.
# You may need to alter the library paths in LIBS below
# I use C: and set C$Path adfs::4.lib.Clib.,adfs::4.lib.Risc_OSLib.
#
ASFLAGS = -quit
CFLAGS = -c -throwback
OBJS = o.ckcfn2 o.ckcfns o.ckcpro o.ckacmd o.ckacom o.ckadia o.ckafio o.ckamai\
       o.ckamis o.ckascr o.ckatio o.ckaus3 o.ckausr o.ckuus2
LIBS = C:o.stubs C:o.risc_oslib

all: kermit

kermit: o.panoslib $(OBJS)
	link -o kermit $(OBJS) o.panoslib $(LIBS)
	squeeze kermit

o.panoslib: o.plib o.buffer o.rs423
	libfile -c -o o.panoslib o.plib o.buffer o.rs423

o.plib: c.plib
	cc -c $(CFLAGS) c.plib

o.buffer: c.buffer
	cc -c $(CFLAGS) -DOUTPUTTOO c.buffer

o.rs423: s.rs423
	objasm $(ASFLAGS) s.rs423 o.rs423

o.ckcfn2: c.ckcfn2
        cc $(CFLAGS) c.ckcfn2

o.ckcfns: c.ckcfns
        cc $(CFLAGS) c.ckcfns

o.ckcpro: c.ckcpro
        cc $(CFLAGS) c.ckcpro

o.ckacmd: c.ckacmd
        cc $(CFLAGS) c.ckacmd

o.ckacom: c.ckacom
        cc $(CFLAGS) c.ckacom

o.ckadia: c.ckadia
        cc $(CFLAGS) c.ckadia

o.ckafio: c.ckafio
        cc $(CFLAGS) c.ckafio

o.ckamai: c.ckamai
        cc $(CFLAGS) c.ckamai

o.ckamis: c.ckamis
        cc $(CFLAGS) c.ckamis

o.ckascr: c.ckascr
        cc $(CFLAGS) c.ckascr

o.ckatio: c.ckatio
        cc $(CFLAGS) c.ckatio

o.ckaus3: c.ckaus3
        cc $(CFLAGS) c.ckaus3

o.ckausr: c.ckausr
        cc $(CFLAGS) c.ckausr

o.ckuus2: c.ckuus2
        cc $(CFLAGS) c.ckuus2
