# Make file for CC Kermit using Microsoft's Make version 5.00
# Written by Quanfang Zhang
# Edit this file for your system dependent modules. Blank lines are mandatory.

# The inference macro below calls MASM to create .obj modules.
 .asm.obj:
	MASM $*.asm;

# These are the dependency relations (.obj depends on .asm , .h and	.dat):

cchkos.obj:	cchkos.asm ccsdef.h 

ccscmd.obj:	ccscmd.asm ccsdef.h ccscmd.dat

ccscom.obj:	ccscom.asm ccsdef.h ccscom.dat

ccsfil.obj:	ccsfil.asm ccsdef.h ccsfil.dat

ccsker.obj:	ccsker.asm ccsdef.h ccsker.dat

ccsrcv.obj:	ccsrcv.asm ccsdef.h ccsrcv.dat

ccsscp.obj:	ccsscp.asm ccsdef.h ccsscp.dat

ccssen.obj:	ccssen.asm ccsdef.h ccssen.dat

ccsser.obj:	ccsser.asm ccsdef.h ccsser.dat

ccsset.obj:	ccsset.asm ccsdef.h ccsset1.dat ccsset2.dat

ccster.obj:	ccster.asm ccsdef.h ccster.dat

ccuibm.obj:	ccuibm.asm ccsdef.h ccuibm.dat

ccgibm.obj:	ccgibm.asm ccsdef.h ccgibm.dat

ccxibm.obj:	ccxibm.asm ccsdef.h ccxibm.dat

ccyibm.obj:	ccyibm.asm ccsdef.h ccyibm.dat

cczibm.obj:	cczibm.asm ccsdef.h cczibm.dat

ccvibm.exe:	cchkos.obj ccscmd.obj ccscom.obj ccsfil.obj ccsker.obj\
		ccsrcv.obj ccsscp.obj ccssen.obj ccsser.obj ccsset.obj\
		ccster.obj ccuibm.obj ccgibm.obj ccxibm.obj ccyibm.obj\
		cczibm.obj
	LINK @ccvibm.lnk
	Echo Make Kermit is done.

# Do the items above when ccvibm.exe is rebuilt. Notice the use of a command
# file for Link because the list of object files is too long for one line.
# A sample command file ccvibm.lnk is:
# cchkos+ccscmd+ccscom+ccsfil+ccsker+ccsrcv+ccsscp+ccssen+
# ccsser+ccsset+ccster+ccgibm+ccuibm+ccxibm+ccyibm+cczibm
# ccvibm;
# End of Kermit Make file.
