/*  C K C M D . H  --  Header file for cmd package  */

/* Sizes of things */

#define MAXINI 8			/* max number of -o commands */
					/* with -o command line option */
#define HLPLW  78			/* Width of ?-help line */
#define HLPCW  19			/* Width of ?-help column */
#define CMDBL  200			/* Command buffer length */
#define HLPBL  100			/* Help string buffer length */
#define ATMBL  100			/* Command atom buffer length*/

/* Special characters */

#define NUL  '\0'			/* Null */
#define HT   '\t'			/* Horizontal Tab */
#define NL   '\n'			/* Newline */
#define FF   0014			/* Formfeed    CTOS "NEXT PAGE" */
#define RDIS 0xf2			/* Redisplay   CTOS "CODE + R" */
#define LDEL 0xf5			/* Delete line CTOS "CODE + U" */
#define WDEL 0xf7			/* Delete word CTOS "CODE + W" */
#define ESC  0033			/* Escape      CTOS "GO" */
#define RUB  0177			/* Rubout      CTOS "DELETE" */

#ifndef BEL
#define BEL  0007			/* Bell        CTOS "CANCEL" */
#endif

#ifndef BS
#define BS   0010			/* Backspace */
#endif

#ifndef SP
#define SP   0040			/* Space */
#endif

/* Keyword table flags */

#define CM_INV 1			/* Invisible keyword */

/* Keyword Table Template */

struct keytab {				/* Keyword table */
    char *kwd;				/* Pointer to keyword string */
    int val;				/* Associated value */
    int flgs;				/* Flags (as defined above) */
};
