IMPLEMENTATION MODULE KermGet;
(************************************************************************)
(* Get a file from remote server                                        *)
(* written:            14.12.85     Matthias Aebi                       *)
(* last modification:  18.03.86     Matthias Aebi                       *)
(************************************************************************)

FROM Terminal    IMPORT WriteString;
FROM KermRecv    IMPORT SwitchRecv;
FROM KermSend    IMPORT SendPacket;
FROM KermMisc    IMPORT DispMsg;
FROM String      IMPORT Length;
FROM TextScreen  IMPORT SetPos;
FROM M2Kermit    IMPORT Param1, Param2;

(************************************************************************)
                              PROCEDURE Get;
(************************************************************************)
VAR
    retCd : BOOLEAN;

BEGIN
    IF Param1[0] = "?"
    THEN
        WriteString("Specify the file to get from remote server");
    ELSE
        IF Param2[0] = 0C
        THEN
            SendPacket("R",0,Length(Param1), Param1);
            retCd := SwitchRecv("");
        ELSE
            SendPacket("R",0,Length(Param2), Param2);
            retCd := SwitchRecv(Param1);
        END;

        IF retCd
        THEN
            DispMsg("Get successful");
        END;
        SetPos(27,0);
    END;

END Get;

END KermGet.
