IMPLEMENTATION MODULE KermHelp;
(************************************************************************)
(*  Help lists all valid commands of Modula-2 Kermit and gives a short  *)
(*  explanation                                                         *)
(*  written:            08.10.85     Matthias Aebi                      *)
(*  last modification:  25.02.86     Matthias Aebi                      *)
(************************************************************************)

FROM Terminal IMPORT WriteString, WriteLn;
FROM KermMisc IMPORT ClrScr;

PROCEDURE Help;
BEGIN
    ClrScr;
    WriteLn;
    WriteString("The following are valid commands:");
    WriteLn;
    WriteLn;
    WriteString("     Bye         Logout remote server, quit Kermit");
    WriteLn;
    WriteString("     Connect     Connect to remote host and act as a terminal");
    WriteLn;
    WriteString("     DElete      Delete files");
    WriteLn;
    WriteString("     DIrectory   Display directory information");
    WriteLn;
    WriteString("     Exit        Quit Kermit");
    WriteLn;
    WriteString("     Finish      Leave server mode at remote server");
    WriteLn;
    WriteString("     Get         Get the specified file(s) from remote server");
    WriteLn;
    WriteString("     Help        Display this message");
    WriteLn;
    WriteString("     Logout      Shut down remote server");
    WriteLn;
    WriteString("     Quit        Quit Kermit");
    WriteLn;
    WriteString("     Receive     Receive a file from remote host");
    WriteLn;
    WriteString("     SENd        Send a file to remote host");
    WriteLn;
    WriteString("     SERver      Enter server mode");
    WriteLn;
    WriteString("     SET         Set local Kermit parameter");
    WriteLn;
    WriteString("     SHow        Show local parameters");
    WriteLn;
    WriteString("     Type        Display a textfile at the screen");
    WriteLn;
    WriteString("     Version     Display the current M2-Kermit version");
    WriteLn;
    WriteLn;
    WriteString("   Allowable abbreviations are shown in capital letters");
    WriteLn;
END Help;

END KermHelp.
