IMPLEMENTATION MODULE KermParam;
(************************************************************************)
(*  This module initializes and stores all global parameters            *)
(*  written:            09.10.85     Matthias Aebi                      *)
(*  last modification:  25.02.86     Matthias Aebi                      *)
(************************************************************************)

FROM KermMisc IMPORT SetBaud;

BEGIN
    LBaudRate     := 9600;
    LCheckType    := 1;
    LCurrPort     := 1;
    LDebug        := FALSE;
    LEcho         := FALSE;
    LEOLChar      := CHR(13);
    LEscChar      := CHR(28);    (* Ctrl-\ *)
    LFileType     := text;
    LFilNamConv   := TRUE;
    LMaxRetries   := 13;
    LNumOfPad     := 0;
    LPackSize     := 94;
    LPadChar      := CHR(0);
    LParity       := none;
    LPrefChar     := "&";
    LPrompt       := "Kermit-M2";
    LQuoteChar    := "#";
    LStartChar    := CHR(1);    (* SOH *)
    LTimeOut      := 10;
    LTimer        := TRUE;
    LWarning      := TRUE;
    REOLChar      := CHR(13);

    SetBaud(LBaudRate, LCurrPort);
END KermParam.
