!
!  MakeKermit:  Command file to compile and load Kermit.
!
!  To install Kermit-Perq, you will have to:
!       1) In KermitScreen: Change the constant KermitFont to the name of
!          the font file you wish to use in the terminal window.
!       2) In KermitMain: Change the constants MSegFile and HLPFile so the 
!          pathnames of Kermit.MSEG and Kermit.HLP in KermitMain
!          refer to the directories in which these files are located.
!       3) Copy the Kermit-commands .CMD-files into a suitable directory
!          ( e.g. :boot )
!       4) Read the comments below to decide whether this command file will
!          have to be modified before running it.
!
! Assume sys:boot> will always be in the searchlist!
!
! The three first commands will only be required if IOUtils, UtilDefs and 
! MenuUtils is to be installed with Kermit.  Otherwise they will have to
! be reachable in the same way as the system modules.
!
com/norange/error IOUtils.Pas
com/norange/error UtilDefs.Pas
com/norange/error MenuUtils.Pas
!
com/norange/error KermitConnect.Pas
com/norange/error KermitFile.Pas
com/norange/error KermitGlobals.Pas
com/norange/error KermitLineIO.Pas
com/norange/error KermitMain.Pas
com/norange/error KermitParameters.Pas
com/norange/error KermitRead.Pas
com/norange/error KermitScreen.Pas
com/norange/error KermitSend.Pas
!
! Change output file spec. if Kermit.RUN should be located in any other
! directory than sys:boot>
!
link KermitMain ~sys:boot>Kermit
