/*
    CMD_H - header file for QL-Kermit command interpreter

    Based on ckucmd.h, (C) Columbia University
*/


/* Sizes of things */

#define HLPLW      78                            /* Width of ?-help line */
#define HLPCW      19                            /* Width of ?-help column */
#define CMDBL      200                           /* Command buffer length */
#define HLPBL      100                           /* Help string buffer length */
#define ATMBL      100                           /* Command atom buffer length /


/* Keyword table flags */

#define CM_INV     1                             /* Invisible keyword */


/* Keyword table template */

struct keytab
{
    int flgs;                                    /* Flags (as defined above) */
    char *kwd;                                   /* Pointer to keyword string */
    int val;                                     /* Associated value */
};
