/*
  apple.c.  Produce a table of the Apple QuickDraw character set.
  F. da Cruz, Columbia University, 1991.
*/
char *name[] = {
"A diaeresis",
"A ring",
"C cedilla",
"E acute",
"N tilde",
"O diaeresis",
"U diaeresis",
"a acute",
"a grave",
"a circumflex",
"a diaeresis",
"a tilde",
"a ring",
"c cedilla",
"e acute",
"e grave",
"e circumflex",
"e diaeresis",
"i acute",
"i grave",
"i circumflex",
"i diaeresis",
"n tilde",
"o acute",
"o grave",
"o circumflex",
"o diaeresis",
"o tilde",
"u acute",
"u grave",
"u circumflex",
"u diaeresis",
"Dagger",
"Degree sign",
"Cent sign",
"Pound Sterling sign",
"Paragraph",
"Center dot",
"Pilcrow sign",
"German sharp s",
"Registered trademark symbol",
"Copyright symbol",
"TM",
"Acute accent",
"Diaeresis",
"Not equals sign",
"AE digraph",
"O slash",
"Infinity symbol",
"Plus or minus sign",
"Less than or equal sign",
"Greater than or equal sign",
"Yen sign",
"Greek mu",
"Greek delta",
"Greek Sigma",
"Greek Pi",
"Greek pi",
"Integral sign",
"Feminine ordinal",
"Masculine ordinal",
"Greek Omega",
"ae digraph",
"o slash",
"Question mark inverted",
"Exclamation mark inverted",
"Not sign",
"Radical sign",
"Florin sign",
"Approximately equal sign",
"Greek Delta",
"Left angle quotation",
"Right angle quotation",
"Ellipsis",
"Word space",
"A grave",
"A tilde",
"O tilde",
"OE digraph",
"oe digraph",
"En-dash",
"Em-dash",
"Left doublequote",
"Right doublequote",
"Left singlequote",
"Right singlequote",
"Divide sign",
"Diamond",
"y diaeresis",
"Y diaeresis",
"Slash",
"International currency symbol",
"Left angle bracket",
"Right angle bracket",
"fi ligature",
"fl ligature",
"Double dagger",
"Center dot",
"Baseline singlequote",
"Baseline doublequote",
"Per mil",
"A circumflex",
"E circumflex",
"A acute",
"E diaeresis",
"E grave",
"I acute",
"I circumflex",
"I diaeresis",
"I grave",
"O acute",
"O circumflex",
"Apple symbol",
"O grave",
"U acute",
"U circumflex",
"U grave",
"i dotless",
"Circumflex",
"Tilde",
"Macron (overbar)",
"Breve",
"Dot accent",
"Ring above",
"Cedilla",
"Hungarian umlaut",
"Ogonek",
"Caron or hacek"
};

main() {
    int i;
    printf("Apple Quickdraw Character Set\n");
    printf("char dec col/row oct hex  description\n");
    for (i = 128; i < 256; i++) {
	printf("[%c]  %3d  %02d/%02d  %3o  %2X  %s\n",
	       i, i, i/16, i%16, i, i, name[i-128]);
    }
}

