/*
  ascii.c.  Produce a table of the DEC Special Graphics Character Set.
  F. da Cruz, Columbia University, 1991.
*/
char *name[] = {
    "SPACE",
    "EXCLAMATION MARK",
    "QUOTATION MARK",
    "NUMBER SIGN",
    "DOLLAR SIGN",
    "PERCENT SIGN",
    "AMPERSAND",
    "APOSTROPHE",
    "LEFT PARENTHESIS",
    "RIGHT PARENTHESIS",
    "ASTERISK",
    "PLUS SIGN",
    "COMMA",
    "HYPHEN, MINUS SIGN",
    "PERIOD, FULL STOP",
    "SOLIDUS, SLASH",
    "DIGIT ZERO",
    "DIGIT ONE",
    "DIGIT TWO",
    "DIGIT THREE",
    "DIGIT FOUR",
    "DIGIT FIVE",
    "DIGIT SIX",
    "DIGIT SEVEN",
    "DIGIT EIGHT",
    "DIGIT NINE",
    "COLON",
    "SEMICOLON",
    "LESS-THAN SIGN, LEFT ANGLE BRACKET",
    "EQUALS SIGN",
    "GREATER-THAN SIGN, RIGHT ANGLE BRACKET",
    "QUESTION MARK",
    "COMMERCIAL AT SIGN",
    "CAPITAL LETTER A",
    "CAPITAL LETTER B",
    "CAPITAL LETTER C",
    "CAPITAL LETTER D",
    "CAPITAL LETTER E",
    "CAPITAL LETTER F",
    "CAPITAL LETTER G",
    "CAPITAL LETTER H",
    "CAPITAL LETTER I",
    "CAPITAL LETTER J",
    "CAPITAL LETTER K",
    "CAPITAL LETTER L",
    "CAPITAL LETTER M",
    "CAPITAL LETTER N",
    "CAPITAL LETTER O",
    "CAPITAL LETTER P",
    "CAPITAL LETTER Q",
    "CAPITAL LETTER R",
    "CAPITAL LETTER S",
    "CAPITAL LETTER T",
    "CAPITAL LETTER U",
    "CAPITAL LETTER V",
    "CAPITAL LETTER W",
    "CAPITAL LETTER X",
    "CAPITAL LETTER Y",
    "CAPITAL LETTER Z",
    "LEFT SQUARE BRACKET",
    "REVERSE SOLIDUS, BACKSLASH",
    "RIGHT SQUARE BRACKET",
    "CIRCUMFLEX ACCENT",
    "BLANK",
    "DIAMOND",
    "CHECKERBOARD (ERROR INDICATION)",
    "HORIZONTAL TAB SYMBOL",
    "FORM FEED SYMBOL",
    "CARRIAGE RETURN SYMBOL",
    "LINEFEED SYMBOL",
    "DEGREE SYMBOL",
    "PLUS OR MINUS SYMBOL",
    "NEW LINE SYMBOL",
    "VERTICAL TAB SYMBOL",
    "LOWER-RIGHT BOX CORNER",
    "UPPER-RIGHT BOX CORNER",
    "UPPER-LEFT BOX CORNER",
    "LOWER-LEFT BOX CORNER",
    "CROSSING LINES",
    "HORIZONTAL LINE - SCAN 1",
    "HORIZONTAL LINE - SCAN 3",
    "HORIZONTAL LINE - SCAN 5",
    "HORIZONTAL LINE - SCAN 7",
    "HORIZONTAL LINE - SCAN 9",
    "LEFT BOX-DRAWING 'T'",
    "RIGHT BOX-DRAWING 'T'",
    "BOTTOM BOX-DRAWING 'T'",
    "TOP BOX-DRAWING 'T'",
    "VERTICAL LINE",
    "LESS-THAN-OR-EQUAL-TO SYMBOL",
    "GREATER-THAN-OR-EQUAL-TO SYMBOL",
    "LOWERCASE GREEK LETTER PI",
    "NOT-EQUAL-TO SYMBOL",
    "POUND STERLING SIGN",
    "CENTERED DOT",
    "RUBOUT, DELETE"
};

main() {
    int i, j;
    char c;

    printf("DEC Special Graphics\n");
    printf("char dec col/row oct hex  description\n");
    for (i = 32; i < 128; i++) {
	j = i - 32;
	c = (i == 127) ? 32 : i;
	printf("(%c)  %3d  %02d/%02d  %3o  %2X  %s\n",
	       c, i, i/16, i%16, i, i, name[j]);
    }
}
