/*
  decmcs.c.  Produce a table of the DEC Multinational Character Set.
  F. da Cruz, Columbia University, 1991.
*/
char *name[] = {
   "Undefined",
   "Inverted exclamation",
   "Cent sign",
   "Pound sign",
   "Undefined",
   "Yen sign",
   "Undefined",
   "Paragraph sign",
   "Currency symbol",
   "Copyright sign",
   "Feminine ordinal",
   "Left angle quotation",
   "Undefined",
   "Undefined",
   "Undefined",
   "Undefined",
   "Degree sign, ring above",
   "Plus-minus sign",
   "Superscript two",
   "Superscript three",
   "Undefined",
   "Micro sign",
   "Pilcrow sign",
   "Middle dot",
   "Undefined",
   "Superscript one",
   "Masculine ordinal",
   "Right angle quotation",
   "One quarter",
   "One half",
   "Undefined",
   "Inverted question mark",
   "A grave",
   "A acute",
   "A circumflex",
   "A tilde",
   "A diaeresis",
   "A ring above",
   "A with E",
   "C Cedilla",
   "E grave",
   "E acute",
   "E circumflex",
   "E diaeresis",
   "I grave",
   "I acute",
   "I circumflex",
   "I diaeresis",
   "Undefined",
   "N tilde",
   "O grave",
   "O acute",
   "O circumflex",
   "O tilde",
   "O diaeresis",
   "OE digraph",
   "O oblique stroke",
   "U grave",
   "U acute",
   "U circumflex",
   "U diaeresis",
   "Y acute",
   "Undefined",
   "German sharp s",
   "a grave",
   "a acute",
   "a circumflex",
   "a tilde",
   "a diaeresis",
   "a ring above",
   "a with e",
   "c cedilla",
   "e grave",
   "e acute",
   "e circumflex",
   "e diaeresis",
   "i grave",
   "i acute",
   "i circumflex",
   "i diaeresis",
   "Undefined",
   "n tilde",
   "o grave",
   "o acute",
   "o circumflex",
   "o tilde",
   "o diaeresis",
   "oe digraph",
   "o oblique stroke",
   "u grave",
   "u acute",
   "u circumflex",
   "u diaeresis",
   "y diaeresis",
   "Undefined",
   "Undefined"
};


main() {
    int i, j;
    printf("DEC Multinational Character Set\n");
    printf("char dec col/row oct hex  description\n");
    for (i = 160; i < 256; i++) {
	j = i - 160;
	printf("[%c]  %3d  %02d/%02d  %3o  %2X  %s\n",
	       i, i, i/16, i%16, i, i, name[j]);
    }
}
