/*
  koi8.c.  Produce a table of the "Old KOI-8" Cyrillic character set.
  F. da Cruz, Columbia University, 1993.
*/
char *name[] = {
    "(undefined)",
    "(undefined)",
    "(undefined)",
    "(undefined)",
    "(undefined)",
    "(undefined)",
    "(undefined)",
    "(undefined)",
    "(undefined)",
    "(undefined)",
    "(undefined)",
    "(undefined)",
    "(undefined)",
    "(undefined)",
    "(undefined)",
    "(undefined)",
    "(undefined)",
    "(undefined)",
    "(undefined)",
    "(undefined)",
    "(undefined)",
    "(undefined)",
    "(undefined)",
    "(undefined)",
    "(undefined)",
    "(undefined)",
    "(undefined)",
    "(undefined)",
    "(undefined)",
    "(undefined)",
    "(undefined)",
    "(undefined)",
    "Cyrillic yu",
    "Cyrillic a",
    "Cyrillic be",
    "Cyrillic tse",
    "Cyrillic de",
    "Cyrillic ie",
    "Cyrillic ef",
    "Cyrillic ghe",
    "Cyrillic ha",
    "Cyrillic i",
    "Cyrillic short i",
    "Cyrillic ka",
    "Cyrillic el",
    "Cyrillic em",
    "Cyrillic en",
    "Cyrillic o",
    "Cyrillic pe",
    "Cyrillic ya",
    "Cyrillic er",
    "Cyrillic es",
    "Cyrillic te",
    "Cyrillic u",
    "Cyrillic zhe",
    "Cyrillic ve",
    "Cyrillic soft sign",
    "Cyrillic yeri",
    "Cyrillic ze",
    "Cyrillic sha",
    "Cyrillic e",
    "Cyrillic shcha",
    "Cyrillic che",
    "Cyrillic hard sign",
    "Cyrillic Yu",
    "Cyrillic A",
    "Cyrillic Be",
    "Cyrillic Tse",
    "Cyrillic De",
    "Cyrillic Ie",
    "Cyrillic Ef",
    "Cyrillic Ghe",
    "Cyrillic Ha",
    "Cyrillic I",
    "Cyrillic Short i",
    "Cyrillic Ka",
    "Cyrillic El",
    "Cyrillic Em",
    "Cyrillic En",
    "Cyrillic O",
    "Cyrillic Pe",
    "Cyrillic Ya",
    "Cyrillic Er",
    "Cyrillic Es",
    "Cyrillic Te",
    "Cyrillic U",
    "Cyrillic Zhe",
    "Cyrillic Ve",
    "Cyrillic Soft Sign",
    "Cyrillic Yeri",
    "Cyrillic Ze",
    "Cyrillic Sha",
    "Cyrillic E",
    "Cyrillic Shcha",
    "Cyrillic Che",
    "DEL"
};

main() {
    int i, j;
    printf("Old KOI-8 (GOST 19768-74)\n");
    printf("char dec col/row oct hex  description\n");
    for (i = 160; i < 256; i++) {
	j = i - 160;
	printf("[%c]  %3d  %02d/%02d  %3o  %2X  %s\n",
	       i, i, i/16, i%16, i, i, name[j]);
    }
}
