; Port-to-Screen mappings for Latin-2 to CP852 for MS-DOS Kermit 3.0 or later.
;
; CP852 is the East European code page for Czech, Polish, Hungarian, etc.
; It is supplied with DOS 5.0.  To use it, put something like this in your
; CONFIG.SYS file:
;
;  COUNTRY=001,850,C:\DOS\COUNTRY.SYS
;  DEVICEHIGH=C:\DOS\DISPLAY.SYS CON:=(EGA,437,(4,3))
;
; and in your AUTOEXEC.BAT file:
;
;  NLSFUNC C:\DOS\COUNTRY.SYS
;  MODE CON: CP PREPARE=((850,,437,852) C:\DOS\EGA.CPI)
;  MODE CON: CP PREPARE=((,866,,) C:\LOCAL\XTRA.CPI)
;  MODE CON: CP SELECT=850
;  MODE CON: CP /STATUS
;  KEYB US,850,C:\DOS\KEYBOARD.SYS
;
; If you want to enter these characters, but you don't have a suitable 
; keyboard and/or driver, you will have to make lots of key mappings with 
; Kermit's SET KEY command, assigning each Latin-2 character to the key
; or key-combination of your choice.
;
; F. da Cruz, Columbia University, June 1992
;
set termin displ 8
set transl input \x80 \xAE  ; The first 32 are the Latin-2 C1 control range
set transl input \x81 \xAF  ; They map to line and box-drawing characters.
set transl input \x82 \xB0
set transl input \x83 \xB1
set transl input \x84 \xB2
set transl input \x85 \xB3
set transl input \x86 \xB4
set transl input \x87 \xB9
set transl input \x88 \xBA
set transl input \x89 \xBB
set transl input \x8A \xBC
set transl input \x8B \xBF
set transl input \x8C \xC0
set transl input \x8D \xC1
set transl input \x8E \xC2
set transl input \x8F \xC3
set transl input \x90 \xC4
set transl input \x91 \xC5
set transl input \x92 \xC8
set transl input \x93 \xC9
set transl input \x94 \xCA
set transl input \x95 \xCB
set transl input \x96 \xCC
set transl input \x97 \xCD
set transl input \x98 \xCE
set transl input \x99 \xD9
set transl input \x9A \xDA
set transl input \x9B \xDB
set transl input \x9C \xDC
set transl input \x9D \xDF
set transl input \x9E \xF0
set transl input \x9F \xFE
set transl input \xA0 \xFF  ; Now the characters that Latin-2 and CP852
set transl input \xA1 \xA4  ; have in common...
set transl input \xA2 \xF4
set transl input \xA3 \x9D
set transl input \xA4 \xCF
set transl input \xA5 \x95
set transl input \xA6 \x97
set transl input \xA7 \xF5
set transl input \xA8 \xF9
set transl input \xA9 \xE6
set transl input \xAA \xB8
set transl input \xAB \x9B
set transl input \xAC \x8D
set transl input \xAD \xAA
set transl input \xAE \xA6
set transl input \xAF \xBD
set transl input \xB0 \xF8
set transl input \xB1 \xA5
set transl input \xB2 \xF2
set transl input \xB3 \x88
set transl input \xB4 \xEF
set transl input \xB5 \x96
set transl input \xB6 \x98
set transl input \xB7 \xF3
set transl input \xB8 \xF7
set transl input \xB9 \xE7
set transl input \xBA \xAD
set transl input \xBB \x9C
set transl input \xBC \xAB
set transl input \xBD \xF1
set transl input \xBE \xA7
set transl input \xBF \xBE
set transl input \xC0 \xE8
set transl input \xC1 \xB5
set transl input \xC2 \xB6
set transl input \xC3 \xC6
set transl input \xC4 \x8E
set transl input \xC5 \x91
set transl input \xC6 \x8F
set transl input \xC7 \x80
set transl input \xC8 \xAC
set transl input \xC9 \x90
set transl input \xCA \xA8
set transl input \xCB \xD3
set transl input \xCC \xB7
set transl input \xCD \xD6
set transl input \xCE \xD7
set transl input \xCF \xD2
set transl input \xD0 \xD1
set transl input \xD1 \xE3
set transl input \xD2 \xD5
set transl input \xD3 \xE0
set transl input \xD4 \xE2
set transl input \xD5 \x8A
set transl input \xD6 \x99
set transl input \xD7 \x9E
set transl input \xD8 \xFC
set transl input \xD9 \xDE
set transl input \xDA \xE9
set transl input \xDB \xEB
set transl input \xDC \x9A
set transl input \xDD \xED
set transl input \xDE \xDD
set transl input \xDF \xE1
set transl input \xE0 \xEA
set transl input \xE1 \xA0
set transl input \xE2 \x83
set transl input \xE3 \xC7
set transl input \xE4 \x84
set transl input \xE5 \x92
set transl input \xE6 \x86
set transl input \xE7 \x87
set transl input \xE8 \x9F
set transl input \xE9 \x82
set transl input \xEA \xA9
set transl input \xEB \x89
set transl input \xEC \xD8
set transl input \xED \xA1
set transl input \xEE \x8C
set transl input \xEF \xD4
set transl input \xF0 \xD0
set transl input \xF1 \xE4
set transl input \xF2 \xE5
set transl input \xF3 \xA2
set transl input \xF4 \x93
set transl input \xF5 \x8B
set transl input \xF6 \x94
set transl input \xF7 \xF6
set transl input \xF8 \xFD
set transl input \xF9 \x85
set transl input \xFA \xA3
set transl input \xFB \xFB
set transl input \xFC \x81
set transl input \xFD \xEC
set transl input \xFE \xEE
set transl input \xFF \xFA
set transl input on
