/*
  next.c.  Produce a table of the NeXT workstation character set.
  F. da Cruz, Columbia University, 1991.
*/
char *name[] = {
    "No-break space",
    "A grave",
    "A acute",
    "A circumflex",
    "A tilde",
    "A diaeresis",
    "A ring",
    "C cedilla",
    "E grave",
    "E acute",
    "E circumflex",
    "E diaeresis",
    "I grave",
    "I acute",
    "I circumflex",
    "I diaeresis",
    "Icelandic Eth",
    "N tilde",
    "O grave",
    "O acute",
    "O circumflex",
    "O tilde",
    "O diaeresis",
    "U grave",
    "U acute",
    "U circumflex",
    "U diaeresis",
    "Y acute",
    "Icelandic Thorn",
    "Greek mu",
    "Multiply sign",
    "Divide sign",
    "Copyright symbol",
    "Inverted exclamation",
    "Cent sign",
    "Pound sterling sign",
    "Slant",
    "Yen sign",
    "Florin sign",
    "Paragraph sign",
    "International currency sign",
    "Apostrophe",
    "Left doublequote",
    "Left angle quotation",
    "Left bracket",
    "Right bracket",
    "fi ligature",
    "fl ligature",
    "Registered trade mark sign",
    "En-dash",
    "Dagger",
    "Double dagger",
    "Small center dot",
    "Broken vertical bar",
    "Pilcrow sign",
    "Large center dot",
    "Baseline singlequote",
    "Baseline doublequote",
    "Right doublequote",
    "Right angle quotation",
    "Ellipsis",
    "Per Mil",
    "Not sign",
    "Question mark inverted",
    "Superscript 1",
    "Grave accent",
    "Acute accent",
    "Circumflex",
    "Tilde",
    "Macron",
    "Breve",
    "Dot above",
    "Diaeresis",
    "Superscript 2",
    "Ring above",
    "Cedilla",
    "Superscript 3",
    "Hungarian umlaut",
    "Ogonek",
    "Caron",
    "Em-dash",
    "Plus or minus sign",
    "One quarter",
    "One half",
    "Three quarters",
    "a grave",
    "a acute",
    "a circumflex",
    "a tilde",
    "a diaeresis",
    "a ring",
    "c cedilla",
    "e grave",
    "e acute",
    "e circumflex",
    "e diaeresis",
    "i grave",
    "AE digraph",
    "i acute",
    "Feminine ordinal",
    "i circumflex",
    "i diaeresis",
    "Icelandic eth",
    "n tilde",
    "L with stroke",
    "O with slash",
    "OE digraph",
    "Masculine ordinal",
    "o grave",
    "o acute",
    "o circumflex",
    "o tilde",
    "o diaeresis",
    "ae digraph",
    "u grave",
    "u acute",
    "u circumflex",
    "i dotless",
    "u diaeresis",
    "y acute",
    "l with stroke",
    "o with slash",
    "oe digraph",
    "German sharp s",
    "Icelandic thorn",
    "y diaeresis",
    "Unknown",
    "Unknown"
};

main() {
    int i;
    printf("NeXT Character Set\n");
    printf("char dec col/row oct hex  description\n");
    for (i = 128; i < 256; i++) {
	printf("[%c]  %3d  %02d/%02d  %3o  %2X  %s\n",
	       (unsigned char) i, i, i/16, i%16, i, i, name[i-128]);
    }
}
