# $Id: ckmker.mak.rick,v 1.6 91/12/15 23:19:55 rick Exp $
# $Source: /uw/mackermit/RCS/ckmker.mak.rick,v $
#------------------------------------------------------------------
# $Log:	ckmker.mak.rick,v $
# Revision 1.6  91/12/15  23:19:55  rick
# ut9
# 
# Revision 1.5  91/10/13  13:43:26  rick
# UT(7)
# 
# Revision 1.4  91/09/25  12:17:09  rick
# Command window in TE. Multiple vt100 windows for command window.
# 
# Revision 1.3  91/09/12  21:50:45  rick
# UT(3). Install on watsun
# 
# Revision 1.2  1991/09/10  22:21:43  rick
# Update to UTexas(2)
#
# Revision 1.1  1991/09/10  19:17:56  rick
# Initial revision
#
#------------------------------------------------------------------
# $Endlog$

# WARNING: MPW 3.2 or later is required to build Mac Kermit with
# interactive command parser / script language support.
#
# MPW make file for MacKermit 0.99(92) created by "Build"
#
#   File:       Kermit.make
#   Target:     Kermit
#   Sources:    ckcfn2.c
#               ckcfns.c
#               ckcmai.c
#               ckcpro.w
#				ckmco2.c
#               ckmcon.c
#               ckmfio.c
#				ckmini.c
#               ckmker.r
#               ckmkey.c
#				ckmpri.c
#               ckmrem.c
#               ckmsav.c
#               ckmscr.c
#               ckmsfp.c
#               ckmtio.c
#               ckmusr.c
#               ckmutl.c
#   Created:    Sonntag, 4. Oktober 1987 18:24:44 Uhr
#	Modified:	Tuesday, December 1, 1987 15:35:13 by PWP:
#			make the .c.o files dependent on the appropriate
#			.h files also
#
# -b : put string constants into code
# -mbg ch8 : create v2.0 compat. MacsBug symbols
# -r : warn on calling an undefined function
# -d MAC : Macintosh version of CKermit
# -d MPW : We are using the MPW 3.0 C compiler
# -w do not display warnings
# -q2 no external memory changes
# -u PROFILE : if you want to do profiling, then change this to -d PROFILE,
#   and add the commented out lines in the link, further down in this file.
# -d TLOG : Include transaction logging code in Kermit
#

# Definitions for Kermit without parser support, uncomment following
# line, comment the other CKCDefns line, and make OKermit.
# 
#CKCDefns = -d MAC -d TLOG -u PROFILE -d DEBUG -d IFDEBUG -d DYNAMIC 
# -d NOICP -u NETCONN -d NOCMDL -d NOCCTRAP
#
# Definitions for Kermit with parser support.
#
CKCDefns = -d MAC -d TLOG -u PROFILE -d DEBUG -d IFDEBUG -d DYNAMIC 
-u NETCONN -d NOCMDL -d NOCCTRAP -d NOHELP -d NOCYRIL -d NOLATIN2 -d CK_ANSIC

#
# MPW 3.2 Final (earlier MPW versions cannot be used)
#
COptions = -opt full -sym full -model farData -mbg ch8 -b -d MPW -d MPW32 
-d dangerousPattern {CKCDefns}
#Kermit  Kermit
#Wart  Wart

ckcfn2.c.o  ckcfn2.c ckcsym.h ckcker.h ckcdeb.h ckcxla.h ckmxla.h ckcasc.h
	C -s ckcfn2 {COptions} ckcfn2.c

ckcfn3.c.o  ckcfn3.c ckcdeb.h ckcasc.h ckcker.h ckcxla.h ckmxla.h
	C -s ckcfn3 {COptions} ckcfn3.c

ckcfns.c.o  ckcfns.c ckcsym.h ckcker.h ckcdeb.h ckcxla.h ckmxla.h ckcasc.h
	C -s ckcfns {COptions} ckcfns.c

ckcmai.c.o  ckcmai.c ckcsym.h ckcker.h ckcdeb.h ckcxla.h ckmxla.h 
ckcasc.h ckmcon.h ckmptp.h
	C -s ckmini {COptions} ckcmai.c

ckucmd.c.o  ckucmd.c ckcasc.h ckcdeb.h ckucmd.h
	C -s ckucmd {COptions} ckucmd.c
ckuusr.c.o  ckuusr.c ckcdeb.h ckcasc.h ckcker.h ckuusr.h ckcxla.h ckcnet.h
	C -s ckuusr {COptions} ckuusr.c
ckuus2.c.o  ckuus2.c ckcdeb.h ckcnet.h ckcasc.h ckcker.h ckuusr.h ckcxla.h
	C -s ckuus2 {COptions} ckuus2.c
ckuus3.c.o  ckuus3.c ckcdeb.h ckcnet.h ckcasc.h ckcker.h ckuusr.h ckcxla.h
	C -s ckuus3 {COptions} ckuus3.c
ckuus4.c.o  ckuus4.c ckcdeb.h ckcnet.h ckcasc.h ckcker.h ckuusr.h 
ckcxla.h ckuver.h
	C -s ckuus4 {COptions} ckuus4.c
ckuus5.c.o  ckuus5.c ckcdeb.h ckcnet.h ckcasc.h ckcker.h ckuusr.h ckcxla.h
	C -s ckuus5 {COptions} ckuus5.c
ckuus6.c.o  ckuus6.c ckcdeb.h ckcnet.h ckcasc.h ckcker.h ckuusr.h ckcxla.h
	C -s ckuus6 {COptions} ckuus6.c
ckuus7.c.o  ckuus7.c ckucmd.h ckcker.h ckuusr.h ckcdeb.h ckcxla.h
	C -s ckuus7 {COptions} ckuus7.c
ckudia.c.o  ckudia.c ckcdeb.h ckcasc.h ckcker.h ckucmd.h
	C -s ckudia {COptions} ckudia.c
ckuscr.c.o  ckuscr.c ckcdeb.h ckcasc.h ckcker.h ckuusr.h
	C -s ckuscr {COptions} ckuscr.c
ckcnet.c.o  ckcnet.c ckcdeb.h ckcasc.h ckcker.h ckcnet.h
	C -s ckcnet {COptions} ckcnet.c
ckuusx.c.o  ckuusx.c ckcdeb.h ckcnet.h ckcasc.h ckcker.h ckuusr.h 
	C -s ckuusx {COptions} ckuusx.c

ckmxla.c.o  ckmxla.c ckcsym.h ckcker.h ckcdeb.h ckcxla.h ckmxla.h ckmptp.h
	C -s ckmxla {COptions} ckmxla.c

ckmcon.c.o  ckmcon.c ckcdeb.h ckmdef.h ckmasm.h ckmcon.h ckcasc.h ckmptp.h
	C -s ckmcon {COptions} ckmcon.c

ckmco2.c.o  ckmco2.c ckcdeb.h ckmdef.h ckmasm.h ckmcon.h ckmptp.h
	C -s ckmcon {COptions} ckmco2.c

ckcpro.c  ckcpro.w wart
	wart ckcpro.w ckcpro.c
	SetFile ckcpro.c -t TEXT -c 'MPS '

### ckcpro.c must be compiled into the same segment (-s) as ckcfns.c so the 
### check in decode() for what routine to call to write a character works 
### right.  If we do this call across segments, the test fails.
ckcpro.c.o  ckcpro.c ckcker.h ckcdeb.h ckcasc.h
	C -s ckcfns {COptions} ckcpro.c

ckmfio.c.o  ckmfio.c ckcker.h ckcdeb.h ckmdef.h ckmasm.h ckmres.h 
ckmptp.h ckmwin.h
	C -s ckmfio {COptions} ckmfio.c

ckmini.c.o  ckmini.c ckcker.h ckcdeb.h ckmdef.h ckmasm.h ckmres.h 
ckmwin.h ckmptp.h
	C -s ckmini {COptions} ckmini.c

ckmkey.c.o  ckmkey.c ckcker.h ckcdeb.h ckmdef.h ckmres.h ckmptp.h
	C -s ckmkey {COptions} ckmkey.c

ckmpri.c.o  ckmpri.c ckcker.h ckcdeb.h ckmdef.h ckmres.h ckmptp.h
	C -s ckmpri {COptions} ckmpri.c

ckmrem.c.o  ckmrem.c ckcker.h ckcdeb.h ckmdef.h ckmres.h ckcasc.h 
ckmwin.h ckmptp.h
	C -s ckmrem {COptions} ckmrem.c

ckmwin.c.o  ckmwin.c ckcker.h ckcdeb.h ckmdef.h ckmres.h ckcasc.h 
ckmwin.h ckmptp.h
	C -s ckmrem {COptions} ckmwin.c

ckmsav.c.o  ckmsav.c ckcker.h ckcdeb.h ckmdef.h ckmres.h ckmptp.h
	C -s ckmsav {COptions} ckmsav.c

ckmscr.c.o  ckmscr.c ckcker.h ckcdeb.h ckmdef.h ckmres.h ckmptp.h
	C -s ckmscr {COptions} ckmscr.c

ckmsfp.c.o  ckmsfp.c ckcker.h ckcdeb.h ckmdef.h ckmres.h ckmptp.h
	C -s ckmsfp {COptions} ckmsfp.c

ckmtio.c.o  ckmtio.c ckcdeb.h ckmdef.h ckmwin.h ckmptp.h
	C -s ckmtio {COptions} ckmtio.c

ckmusr.c.o  ckmusr.c ckcker.h ckcdeb.h ckmdef.h ckmasm.h ckmres.h 
ckmwin.h ckmptp.h
	C -s ckmusr {COptions} ckmusr.c

ckmutl.c.o  ckmutl.c ckcker.h ckcdeb.h ckmdef.h ckmasm.h ckmres.h 
ckmcon.h ckcasc.h ckmptp.h
	C -s ckmutl {COptions} ckmutl.c

# MPW 3.2 Beta
#
wart  ckwart.c.o
	Link -w -c 'MPS ' -t MPST 
		ckwart.c.o 
		"{Libraries}"stubs.o 
		"{Libraries}"Runtime.o 
		"{Libraries}"Interface.o 
		"{CLibraries}"StdCLib.o 
		"{CLibraries}"CSANELib.o 
		"{CLibraries}"Math.o 
		"{Libraries}"ToolLibs.o 
		-o wart

ckwart.c.o  ckwart.c
	C -d MAC -d MPW ckwart.c

Kermit.res  ckmker.r ckmfnt.r
    Delete -i Kermit.res
	Rez ckmker.r -d TLOG -o Kermit.res -t 'rsrc' -c 'RSED'
	Rez -append ckmfnt.r -o Kermit.res

# OKermit without parser support.
#
OKermit  Kermit.res 
		ckcfn2.c.o 
		ckcfn3.c.o 
		ckcfns.c.o 
		ckcmai.c.o 
		ckcnet.c.o 
		ckmxla.c.o 
		ckcpro.c.o 
		ckmcon.c.o 
		ckmco2.c.o 
		ckmfio.c.o 
		ckmini.c.o 
		ckmkey.c.o 
		ckmpri.c.o 
		ckmrem.c.o 
		ckmsav.c.o 
		ckmscr.c.o 
		ckmsfp.c.o 
		ckmtio.c.o 
		ckmusr.c.o 
		ckmutl.c.o
	Delete -i OKermit
	Duplicate -y Kermit.res OKermit
	Rez -o OKermit -a ckmkr2.r
	Link -map -mf -ra =resProtected -msg nodup 
		-o OKermit -t APPL -c '????' -l 
		ckcfn2.c.o 
		ckcfn3.c.o 
		ckcfns.c.o 
		ckcmai.c.o 
		ckcnet.c.o 
		ckmxla.c.o 
		ckcpro.c.o 
		ckmcon.c.o 
		ckmco2.c.o 
		ckmfio.c.o 
		ckmini.c.o 
		ckmkey.c.o 
		ckmpri.c.o 
		ckmrem.c.o 
		ckmsav.c.o 
		ckmscr.c.o 
		ckmsfp.c.o 
		ckmtio.c.o 
		ckmusr.c.o 
		ckmutl.c.o 
		"{Libraries}"Interface.o 
		"{CLibraries}"StdCLib.o 
		"{Libraries}"Runtime.o 
		> kermit.linkmap
	SetFile OKermit -t APPL -c KR09 -a B

# MPW 3.2 Beta
#
# Kermit with parser support
#
Kermit  Kermit.res 
		ckmkr2.r 
		ckcfn2.c.o 
		ckcfn3.c.o 
		ckcfns.c.o 
		ckcmai.c.o 
		ckucmd.c.o 
		ckuusr.c.o 
		ckuus2.c.o 
		ckuus3.c.o 
		ckuus4.c.o 
		ckuus5.c.o 
		ckuus6.c.o 
		ckuus7.c.o 
		ckudia.c.o 
		ckuscr.c.o 
		ckcnet.c.o 
		ckuusx.c.o 
		ckmxla.c.o 
		ckcpro.c.o 
		ckmcon.c.o 
		ckmco2.c.o 
		ckmfio.c.o 
		ckmini.c.o 
		ckmkey.c.o 
		ckmpri.c.o 
		ckmrem.c.o 
		ckmwin.c.o 
		ckmsav.c.o 
		ckmscr.c.o 
		ckmsfp.c.o 
		ckmtio.c.o 
		ckmusr.c.o 
		ckmutl.c.o
	Delete -i Kermit
	Duplicate -y Kermit.res Kermit
	Rez -o Kermit -a ckmkr2.r
	Link -sym Full -model far -map -mf -ra =resProtected -msg nodup 
		-o Kermit -t APPL -c '????' -l 
		ckcfn2.c.o 
		ckcfn3.c.o 
		ckcfns.c.o 
		ckcmai.c.o 
		ckucmd.c.o 
		ckuusr.c.o 
		ckuus2.c.o 
		ckuus3.c.o 
		ckuus4.c.o 
		ckuus5.c.o 
		ckuus6.c.o 
		ckuus7.c.o 
		ckudia.c.o 
		ckuscr.c.o 
		ckcnet.c.o 
		ckuusx.c.o 
		ckmxla.c.o 
		ckcpro.c.o 
		ckmcon.c.o 
		ckmco2.c.o 
		ckmfio.c.o 
		ckmini.c.o 
		ckmkey.c.o 
		ckmpri.c.o 
		ckmrem.c.o 
		ckmwin.c.o 
		ckmsav.c.o 
		ckmscr.c.o 
		ckmsfp.c.o 
		ckmtio.c.o 
		ckmusr.c.o 
		ckmutl.c.o 
#		"{CLibraries}"CRuntime.o 
		"{Libraries}"Interface.o 
		"{CLibraries}"StdCLib.o 
#		"{CLibraries}"CSANELib.o 
#		"{CLibraries}"Math.o 
#		"{CLibraries}"CInterface.o 
#		"{Libraries}"PerformLib.o 
		"{Libraries}"Runtime.o 
		> kermit.linkmap
		SetFile Kermit -t APPL -c KR09 -a B

Clean 
    Delete -i Kermit.res wart Perform.out
    Delete -i .o
	Delete -i ckcpro.c
