#
#  Makefile for Data General Kermit
#

CFLAGS = -Daosvs -g "-CLS/LINE/PROC/NOINCLUDE/POINTERCH/CHECKOFF"
LFLAGS = "-LTASK=16"

Lintflags =	-Daosvs -Dlint

Includes =	

Source =	kermit.c 

Object =	kermit.o

Binaries =	kermit.pr

Files =		${Includes} ${Source} makefile 

all:		${Binaries}

kermit.pr:	kermit.ob
		${CC} ${CFLAGS} ${LFLAGS} -o kermit kermit.o

install:	all
		cp kermit.pr /usr/bin

lint:
		lint ${Lintflags} ${Source} > lint.ls

print:		${Files}
		pr $? | lpr
		touch print

clean:
		rm -f *.ob *.pr *.st *.ls *.dl *.ds

backup:
		tar cvf .backup ${Files}
