.TH COPYTAPE 1 "17 May 1987"
.SH NAME
copytape \- Reel-to-reel tape copy.
.SH SYNOPSIS
.B copytape [
.B \-d \-v \-f device \-t device
]
.br
.LP
.SH DESCRIPTION
.I copytape
copies one tape to another.
.PP
Options:
.IP \fB\-v\fP 5
Display the program version number and some other information about
the program, including the number and size of tape block buffers.
.IP \fB\-d\fP 5
Display debugging information during tape copy.  This slows the
program down and may cause the output tape to be considerably longer
than the input tape, which for long input tapes may cause the output
tape to run off the end of the reel.
.IP \fB\-f\fP 5
From-tape.  The device specification of the tape to be copied, by default
/dev/rmt12 (drive 0, 1600 bpi, no rewind on close).
.IP \fB\-t\fP 5
To-tape.  The device specification of the output tape, by default
/dev/rmt13 (drive 1, 1600 bpi, no rewind on close).
.SH "NOTES"
-f and -t may be omitted, and will default as indicated.  If they are
included, they must have arguments.  If "0" is given as an argument,
then /dev/rmt12 will be understood; if "1" is given, then /dev/rmt13.
-d and -v may be bundled.  E.g. the command "copytape -dvf 0 -t 1" is
legal.  A "system(date)" command is given at the beginning and the end,
so that the copy operation can be timed.  This information goes to
standard output and can be redirected.
.SH SEE ALSO
mt(4)
.br
.SH AUTHOR
Frank da Cruz, Columbia University Center for Computing Activities,
New York, NY 10027, May 1987.
.br
.SH BUGS
Even without -d, the output tape may be slightly longer than the input tape,
so caution should be used when copying almost-full tapes.
