*COPY                                                 IK0DEF            01400000
         TITLE 'Kermit-370 Control blocks and constants'       @SC86268 01401000
         PRINT NOGEN                                                    01402000
         GBLC  &KVRSN,&KSYS,&KDATE,&RTN,&TYPCMD,&S1CMD,&KCONT  @SC88309 01402200
         GBLC  &KEDIT,&STORDS,&KTAG                            @SC90067 01402400
         GBLA  &MAXLR,&MAXBS                                   @SC86268 01402600
         FDBD  ,                                               @SC86295 01403000
         USING COMMON,10                                       @SC86316 01404000
*                                                                       01407000
&KTAG    SETC  ''                                              @SC90067 01408000
&KVRSN   SETC  '4.2'                                           @SC90072 01410000
&KDATE   SETC  '90/03/13'                                      @SC90072 01411000
&KEDIT   SETC  '0'                                             @SC90072 01411500
*                                                                       01411600
         SYSMACS ,           System-dependent macros           @SC90067 01411700
         SSYMS ,                                               @SC86268 01412000
         USING &STORDS,KWRKBASE                                @SC89268 01412500
* EBCDIC constants                                                      01413000
SOH      EQU   X'01'                 ctl-A in Ascii/Ebcdic              01414000
XON      EQU   X'11'                 xon in Ascii/Ebcdic                01415000
NL       EQU   X'15'                                                    01416000
CR       EQU   X'0D'                 CR in Ascci and Ebcdic             01417000
* Ascii constants                                                       01421000
*   1st, all letters and digits:                               @SC86262 01422000
         ASCSYM ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789           @SC86262 01423000
*   and a few others:                                                   01424000
AHT      EQU   9             ASCII HT                          @SC89301 01424100
ALF      EQU   10            ASCII LF                          @SC89301 01424200
ASUB     EQU   26            ASCII ctrl-Z (soft EOF)           @SC89301 01424300
ABL      EQU   32            ASCII space                                01424400
AEXCL    EQU   33            ASCII exclamation mark            @SC88273 01424500
A#       EQU   35                    Ascii #                            01425000
AAMP     EQU   38                    Ascii ampersand                    01428000
ACOM     EQU   44            ASCII comma                       @SC89301 01429000
ADOT     EQU   46            ASCII period                               01429300
ASL      EQU   47            ASCII slash                       @SC89301 01429600
AUP      EQU   94            Ascii up-arrow (^)                @SC86165 01430000
ADEL     EQU   127                   Ascii delete/rubout                01431000
ATIL     EQU   126                   Ascii Tilde                        01432000
* Flags for extracting filespec                                @SC86295 01433000
FFRCF    EQU   X'40'         RECEIVE or foreign filespec       @SC86295 01434000
FFSND    EQU   X'20'         SEND                              @SC86295 01435000
FFGET    EQU   X'10'         GET                               @SC86295 01436000
FFWLD    EQU   X'08'         Treat incomplete filespec as wild @SC86295 01437000
FFNEW    EQU   X'02'         Get unique name (in place)        @SC86295 01438000
FFUTL    EQU   FFSND+FFGET   Extract for file utility          @SC86295 01439000
FFHDR    EQU   FFUTL+FFRCF   Decode Kermit file header         @SC86295 01440000
FFENC    EQU   FFNEW+FFRCF   Encode Kermit file header         @SC86295 01441000
FFDSP    EQU   FFNEW+FFSND   Copy name in standard print form  @SC86295 01442000
FFGIV    EQU   FFWLD         Like TAKE, but use for output     @SC87117 01443000
* Miscellaneous constants                                               01444000
KMIN     EQU   20                    Kermit protocol minimum pkt size   01445000
KMAX     EQU   94                    Kermit protocol maximum pkt size   01446000
KMAXF    EQU   KMAX+1        Kermit xtended pkt base           @TB86196 01447000
KMAXESIZ EQU   KMAXE+7 SOH+LEN+NUM+TYPE+LENX1+LENX2+HCHECK     @TB86196 01448000
KDEF     EQU   80                    Kermit protocol default pkt size   01449000
LPKT     EQU   KMAXESIZ+KMAX+1 Packet buffer size (with pad)   @SC86202 01450000
MAXNSENT EQU   512           Size of 'sent' table              @SC86190 01451000
MSNDMAX  EQU   12            Max number of extra files to send @SC88306 01451500
TAKMAX   EQU   10                    Max TAKE nesting level             01452000
FORMAXL  EQU   31            Maximum file prefix/suffix size   @HF86223 01453000
TUNECT   EQU   15            Count for retuning long packets   @SC88349 01453500
* 3270 orders:                                                          01454000
SBA      EQU   X'11'                 Set Buffer Address (3270)          01455000
ICR      EQU   X'12'         Insert cursor                     @SC88168 01455500
RTA      EQU   X'3C'         Repeat To Address (3270)          @SC88139 01456000
