//*
//*  NIH TSO KERMIT INSTALLATION JCL
//*
//INSTALL PROC SYSDA=SYSDA,            UNIT NAME FOR SCRATCH DISKS
//             ASM=IEV90,              NAME OF ASSEMBLER
//             LKED=IEWL               NAME OF LINKAGE EDITOR
//*
//*  ASSEMBLE THE TABLES
//*
//ASMTABLE  EXEC  PGM=&ASM,REGION=1000K,PARM='NODECK,OBJECT,TERM'
//*
//SYSTERM  DD  SYSOUT=A
//SYSLIB   DD  DSN=SYS1.MACLIB,DISP=SHR
//SYSLIN   DD  DSN=&&TABLES,UNIT=&SYSDA,DISP=(MOD,PASS,DELETE),
//             SPACE=(CYL,(2,1)),DCB=(RECFM=FB,LRECL=80,BLKSIZE=3200)
//SYSPRINT DD  SYSOUT=A
//SYSUDUMP DD  SYSOUT=A
//SYSUT1   DD  UNIT=&SYSDA,SPACE=(CYL,(10,10))
//SYSUT2   DD  UNIT=&SYSDA,SPACE=(CYL,(10,10))
//SYSUT3   DD  UNIT=&SYSDA,SPACE=(CYL,(10,10))
//*
//*  ASSEMBLE THE UNHEX PROGRAM
//*
//ASMUNHEX  EXEC  PGM=&ASM,REGION=1000K,PARM='NODECK,OBJECT,TERM'
//*
//SYSTERM  DD  SYSOUT=A
//SYSLIB   DD  DSN=SYS1.MACLIB,DISP=SHR
//SYSLIN   DD  DSN=&&UNHEX,UNIT=&SYSDA,DISP=(MOD,PASS,DELETE),
//             SPACE=(CYL,(2,1)),DCB=(RECFM=FB,LRECL=80,BLKSIZE=3200)
//SYSPRINT DD  SYSOUT=A
//SYSUDUMP DD  SYSOUT=A
//SYSUT1   DD  UNIT=&SYSDA,SPACE=(CYL,(10,10))
//SYSUT2   DD  UNIT=&SYSDA,SPACE=(CYL,(10,10))
//SYSUT3   DD  UNIT=&SYSDA,SPACE=(CYL,(10,10))
//*
//*  LINK THE UNHEX PROGRAM
//*
//LNKUNHEX EXEC PGM=&LKED,PARM='MAP,LIST',COND=(8,LE),REGION=500K
//*
//SYSLIN   DD  DSN=&&UNHEX,DISP=(OLD,DELETE)
//SYSLMOD  DD  DSN=&&LOAD(UNHEX),UNIT=&SYSDA,DISP=(NEW,PASS,DELETE),
//             SPACE=(CYL,(2,1,1))
//SYSPRINT DD  SYSOUT=A
//SYSUDUMP DD  SYSOUT=A
//SYSUT1   DD  DSN=&&SYSUT1,UNIT=&SYSDA,SPACE=(CYL,(5,5))
//*
//*  EXECUTE THE UNHEX PROGRAM
//*
//RUNUNHEX  EXEC  PGM=*.LNKUNHEX.SYSLMOD,REGION=500K,COND=(8,LE),
//          PARM=NOUPDTE
//*
//DELETE   DD  DSN=&&LOAD,DISP=(OLD,DELETE)
//OUTPUT   DD  DSN=&&OBJECT,UNIT=&SYSDA,DISP=(NEW,PASS),
//             SPACE=(CYL,(5,5),RLSE),DCB=BLKSIZE=3200
//*
//*  LINK TSO KERMIT
//*
//KERMIT EXEC PGM=&LKED,PARM='MAP,LIST',COND=(8,LE),REGION=500K
//*
//SYSLIN   DD  DSN=&&OBJECT,DISP=(OLD,DELETE)
//         DD  DSN=&&TABLES,DISP=(OLD,DELETE)
//SYSPRINT DD  SYSOUT=A
//SYSUDUMP DD  SYSOUT=A
//SYSUT1   DD  DSN=&&SYSUT1,UNIT=&SYSDA,SPACE=(CYL,(5,5))
//  PEND
//*
//*  EXECUTE THE INSTALLATION PROCEDURE
//*
//  EXEC  INSTALL
//ASMTABLE.SYSIN  DD  DSN=TSNTBL.ASM,DISP=SHR
//ASMUNHEX.SYSIN  DD  DSN=TSNUNH.ASM,DISP=SHR
//RUNUNHEX.INPUT  DD  DSN=TSNKER.OBH,DISP=SHR
//KERMIT.SYSLMOD  DD  DSN=SYS1.KERMLIB(KERMIT),DISP=OLD
