<<< flasi.m09 >>>
*
*  Interrupt handler preprocessor
*
nmivec         equ      $e80c
*
_irqprp:       jsr      _irqhdr
               rti
*
_nmihdr:       jsr      _cleanup
               jmp      [nmivec]
*
_setirq_on:    andcc    #%11101111
               rts
*
               export   _irqprp
               export   _nmihdr
               export   _setirq_on
               import   _cleanup
               import   _irqhdr
*
               end
<<< flasv.m09 >>>
*
*  Return status of input
*
*  D = 0 -> no character available
*  D # 0 -> character available
*
status         equ      $cd4e
*
               loc      0
*
_constat:      jsr      status
               tfr      cc,b
               comb
               andb     #%00000100
               clra
               rts
*
               export   _constat
*              
               end
<<< flasvi.m09 >>>
*
*  Return status of input
*
*  D = 0 -> no character available
*  D # 0 -> character available
*
status         equ      $cd4e
*
               loc      0
*
_constat:      jsr      status
               tfr      cc,b
               comb
               andb     #%00000100
               clra
               rts
*
*  Interrupt handler preprocessor
*
maplt          equ      $ebfc
nmivec         equ      $e80c
*
               loc      1
*
_irqprp:       lda      maplt
               pshs     a
               clr      maplt
               jsr      _irqhdr
               puls     a
               sta      maplt
               rti
*
_nmihdr:       jsr      _cleanup
               jmp      [nmivec]
*
_setirq_on:    andcc    #%11101111
               rts
*
               export   _constat
               export   _irqprp
               export   _nmihdr
               export   _setirq_on
               import   _cleanup
               import   _irqhdr
*
               end
