/*
  ascii.c.  Produce a table of ISO 646 British National Variant.
  F. da Cruz, Columbia University, 1991.
*/
char *name[] = {
    "SPACE",
    "EXCLAMATION MARK",
    "QUOTATION MARK",
    "POUND SIGN",
    "DOLLAR SIGN",
    "PERCENT SIGN",
    "AMPERSAND",
    "APOSTROPHE",
    "LEFT PARENTHESIS",
    "RIGHT PARENTHESIS",
    "ASTERISK",
    "PLUS SIGN",
    "COMMA",
    "HYPHEN, MINUS SIGN",
    "PERIOD, FULL STOP",
    "SOLIDUS, SLASH",
    "DIGIT ZERO",
    "DIGIT ONE",
    "DIGIT TWO",
    "DIGIT THREE",
    "DIGIT FOUR",
    "DIGIT FIVE",
    "DIGIT SIX",
    "DIGIT SEVEN",
    "DIGIT EIGHT",
    "DIGIT NINE",
    "COLON",
    "SEMICOLON",
    "LESS-THAN SIGN, LEFT ANGLE BRACKET",
    "EQUALS SIGN",
    "GREATER-THAN SIGN, RIGHT ANGLE BRACKET",
    "QUESTION MARK",
    "COMMERCIAL AT SIGN",
    "CAPITAL LETTER A",
    "CAPITAL LETTER B",
    "CAPITAL LETTER C",
    "CAPITAL LETTER D",
    "CAPITAL LETTER E",
    "CAPITAL LETTER F",
    "CAPITAL LETTER G",
    "CAPITAL LETTER H",
    "CAPITAL LETTER I",
    "CAPITAL LETTER J",
    "CAPITAL LETTER K",
    "CAPITAL LETTER L",
    "CAPITAL LETTER M",
    "CAPITAL LETTER N",
    "CAPITAL LETTER O",
    "CAPITAL LETTER P",
    "CAPITAL LETTER Q",
    "CAPITAL LETTER R",
    "CAPITAL LETTER S",
    "CAPITAL LETTER T",
    "CAPITAL LETTER U",
    "CAPITAL LETTER V",
    "CAPITAL LETTER W",
    "CAPITAL LETTER X",
    "CAPITAL LETTER Y",
    "CAPITAL LETTER Z",
    "LEFT SQUARE BRACKET",
    "REVERSE SOLIDUS, BACKSLASH",
    "RIGHT SQUARE BRACKET",
    "CIRCUMFLEX ACCENT",
    "LOW LINE, UNDERLINE",
    "GRAVE ACCENT",
    "SMALL LETTER A",
    "SMALL LETTER B",
    "SMALL LETTER C",
    "SMALL LETTER D",
    "SMALL LETTER E",
    "SMALL LETTER F",
    "SMALL LETTER G",
    "SMALL LETTER H",
    "SMALL LETTER I",
    "SMALL LETTER J",
    "SMALL LETTER K",
    "SMALL LETTER L",
    "SMALL LETTER M",
    "SMALL LETTER N",
    "SMALL LETTER O",
    "SMALL LETTER P",
    "SMALL LETTER Q",
    "SMALL LETTER R",
    "SMALL LETTER S",
    "SMALL LETTER T",
    "SMALL LETTER U",
    "SMALL LETTER V",
    "SMALL LETTER W",
    "SMALL LETTER X",
    "SMALL LETTER Y",
    "SMALL LETTER Z",
    "LEFT CURLY BRACKET, LEFT BRACE",
    "VERTICAL LINE, VERTICAL BAR",
    "RIGHT CURLY BRACKET, RIGHT BRACE",
    "TILDE",
    "RUBOUT, DELETE"
};


main() {
    int i, j;
    char c;

    printf("US ASCII, ANSI X3.4-1986\n");
    printf("char dec col/row oct hex  description\n");
    for (i = 32; i < 128; i++) {
	j = i - 32;
	c = (i == 127) ? 32 : i;
	printf("(%c)  %3d  %02d/%02d  %3o  %2X  %s\n",
	       c, i, i/16, i%16, i, i, name[j]);
    }
}
