/*
  cp850.c.  Produce a table of IBM Code Page 850.
  F. da Cruz, Columbia University, 1991.
*/
char *name[] = {
    "C cedilla",
    "u diaeresis",
    "e acute",
    "a circumflex",
    "a diaeresis",
    "a grave",
    "a ring",
    "c cedilla",
    "e circumflex",
    "e diaeresis",
    "e grave",
    "i diaeresis",
    "i circumflex",
    "i grave",
    "A diaeresis",
    "A ring",
    "E acute",
    "ae diphthong",
    "AE diphthong",
    "o circumflex",
    "o diaeresis",
    "o grave",
    "u circumflex",
    "u grave",
    "y diaeresis",
    "O diaeresis",
    "U diaeresis",
    "o slash",
    "Pound sterling sign",
    "O slash",
    "Multiplication sign",
    "Florin sign",
    "a acute",
    "i acute",
    "o acute",
    "u acute",
    "n tilde",
    "N tilde",
    "Feminine ordinal",
    "Masculine ordinal",
    "Question mark inverted",
    "Registered trademark symbol",
    "Logical NOT / End of line symbol",
    "One half",
    "One quarter",
    "Exclamation inverted",
    "Left angle quotes",
    "Right angle quotes",
    "Fill character light",
    "Fill character medium",
    "Fill character heavy",
    "Center box bar vertical",
    "Right middle box side",
    "A acute",
    "A circumflex",
    "A grave",
    "Copyright symbol",
    "Right box side double",
    "Center box vertical double",
    "Upper right box corner double",
    "Lower right box corner double",
    "Cent sign",
    "Yen sign",
    "Upper right box corner",
    "Lower right box corner",
    "Middle box bottom",
    "Middle box top",
    "Left middle box side",
    "Center box bar horizontal",
    "Box intersection",
    "a tilde",
    "A tilde",
    "Lower left box corner double",
    "Upper left box corner double",
    "Middle box bottom double",
    "Middle box top double",
    "Left box side double",
    "Center box bar horizontal double",
    "Box intersection double",
    "International currency symbol",
    "Icelandic eth",
    "Icelandic Eth",
    "E circumflex",
    "E diaeresis",
    "E grave",
    "i dotless",
    "I acute",
    "I circumflex",
    "I diaeresis",
    "Lower right box corner",
    "Upper left box corner",
    "Solid fill character",
    "Solid fill character bottom half",
    "Broken vertical bar",
    "I grave",
    "Solid fill character upper half",
    "O acute",
    "German sharp s",
    "O circumflex",
    "O grave",
    "o tilde",
    "O tilde",
    "Greek mu",
    "Icelandic thorn",
    "Icelandic Thorn",
    "U acute",
    "U circumflex",
    "U grave",
    "y acute",
    "Y acute",
    "Macron (overbar)",
    "Acute accent",
    "Soft hyphen",
    "Plus or minus sign",
    "Double underscore",
    "Three quarters",
    "Pilcrow sign",
    "Paragraph sign",
    "Divide sign",
    "Cedilla",
    "Degree sign",
    "Diaeresis",
    "Center dot",
    "Superscript 1",
    "Superscript 3",
    "Superscript 2",
    "Solid square",
    "Required Space"
};

main() {
    int i;
    printf("IBM Code Page 850\n");
    printf("char dec col/row oct hex  description\n");
    for (i = 128; i < 256; i++) {
	printf("[%c]  %3d  %02d/%02d  %3o  %2X  %s\n",
	       i, i, i/16, i%16, i, i, name[i-128]);
    }
}
