/*
  cyrillic-iso.c.  Produce a table of the ISO 8859-5 Latin/Cyrillic alphabet.
  F. da Cruz, Columbia University, 1991.
*/
char *name[] = {
    "No-break space",
    "Cyrillic Io",
    "Serbocroation Dje",
    "Macedonian Gje",
    "Ukranian Ie",
    "Macedonian Dze",
    "Cyrillic I",
    "Ukranian Yi",
    "Cyrillic Je",
    "Cyrillic Lje",
    "Cyrillic Nje",
    "Serbocroation Chje",
    "Macedonian Kje",
    "Soft hyphen",
    "Bielorussian Short U",
    "Cyrillic Dze",
    "Cyrillic A",
    "Cyrillic Be",
    "Cyrillic Ve",
    "Cyrillic Ghe",
    "Cyrillic De",
    "Cyrillic Ie",
    "Cyrillic Zhe",
    "Cyrillic Ze",
    "Cyrillic I",
    "Cyrillic Short I",
    "Cyrillic Ka",
    "Cyrillic El",
    "Cyrillic Em",
    "Cyrillic En",
    "Cyrillic O",
    "Cyrillic Pe",
    "Cyrillic Er",
    "Cyrillic Es",
    "Cyrillic Te",
    "Cyrillic U",
    "Cyrillic Ef",
    "Cyrillic Ha",
    "Cyrillic Tse",
    "Cyrillic Che",
    "Cyrillic Sha",
    "Cyrillic Shcha",
    "Cyrillic Hard Sign",
    "Cyrillic Yeri",
    "Cyrillic Soft Sign",
    "Cyrillic E",
    "Cyrillic Yu",
    "Cyrillic Ya",
    "Cyrillic a",
    "Cyrillic be",
    "Cyrillic ve",
    "Cyrillic ghe",
    "Cyrillic de",
    "Cyrillic ie",
    "Cyrillic zhe",
    "Cyrillic ze",
    "Cyrillic i",
    "Cyrillic Short i",
    "Cyrillic ka",
    "Cyrillic el",
    "Cyrillic em",
    "Cyrillic en",
    "Cyrillic o",
    "Cyrillic pe",
    "Cyrillic er",
    "Cyrillic es",
    "Cyrillic te",
    "Cyrillic u",
    "Cyrillic ef",
    "Cyrillic ha",
    "Cyrillic tse",
    "Cyrillic che",
    "Cyrillic sha",
    "Cyrillic shcha",
    "Cyrillic hard sign",
    "Cyrillic yeri",
    "Cyrillic soft sign",
    "Cyrillic e",
    "Cyrillic yu",
    "Cyrillic ya",
    "Number Acronym",
    "Cyrillic io",
    "Serbocroation dje",
    "Macedonian gje",
    "Ukranian ie",
    "Macedonian dze",
    "Cyrillic i",
    "Ukranian yi",
    "Cyrillic je",
    "Cyrillic lje",
    "Cyrillic nje",
    "Serbocroatian chje",
    "Macedonian kje",
    "Paragraph sign",
    "Bielorussian short u",
    "Cyrillic dze"
};


main() {
    int i, j;
    printf("char dec col/row oct hex  description\n");
    for (i = 160; i < 256; i++) {
	j = i - 160;
	printf("[%c]  %3d  %02d/%02d  %3o  %2X  %s\n",
	       i, i, i/16, i%16, i, i, name[j]);
    }
}
