/*
  dgmcs.c.  Produce a table of Data General Multincational Character Set.
  F. da Cruz, Columbia University, 1991.
*/
char *name[] = {
   "UNDEFINED",
   "Not sign",
   "One half",
   "Micro sign",
   "Superscript two",
   "Superscript three",
   "Currency sign",
   "Cent sign",
   "Pound sign",
   "Feminine ordinal (a)",
   "Masculine ordinal (o)",
   "Inverted exclamation",
   "Inverted question mark",
   "Copyright sign (C)",
   "Registered trade mark (R)",
   "Double dagger",
   "Right angle quotation",
   "Left angle quotation",
   "Pilcrow sign",
   "TM (trade mark)",
   "Florin sign",
   "Yen sign",
   "Plus-minus sign",
   "Less-than-or-equal sign",
   "Greater-than-or-equal sign",
   "Middle dot",
   "Grave accent",
   "Paragraph sign",
   "Degree sign, ring above",
   "Diaeresis",
   "Acute accent",
   "Up arrow",
   "A acute",
   "A grave",
   "A circumflex",
   "A diaeresis",
   "A tilde",
   "A ring above",
   "A with E",
   "C Cedilla",
   "E acute",
   "E grave",
   "E circumflex",
   "E diaeresis",
   "I acute",
   "I grave",
   "I circumflex",
   "I diaeresis",
   "N tilde",
   "O acute",
   "O grave",
   "O circumflex",
   "O diaeresis",
   "O tilde",
   "O oblique stroke",
   "OE digraph",
   "U acute",
   "U grave",
   "U circumflex",
   "U diaeresis",
   "UNDEFINED",
   "Y diaeresis",
   "UNDEFINED",
   "UNDEFINED",
   "a acute",
   "a grave",
   "a circumflex",
   "a diaeresis",
   "a tilde",
   "a ring above",
   "a with e",
   "c cedilla",
   "e acute",
   "e grave",
   "e circumflex",
   "e diaeresis",
   "i acute",
   "i grave",
   "i circumflex",
   "i diaeresis",
   "n tilde",
   "o acute",
   "o grave",
   "o circumflex",
   "o diaeresis",
   "o tilde",
   "o oblique stroke",
   "oe digraph",
   "u acute",
   "u grave",
   "u circumflex",
   "u diaeresis",
   "German sharp s",
   "y diaeresis",
   "UNDEFINED",
   "Fill character light"
};


main() {
    int i, j;
    printf("Data General International Character Set\n");
    printf("char dec col/row oct hex  description\n");
    for (i = 160; i < 256; i++) {
	j = i - 160;
	printf("[%c]  %3d  %02d/%02d  %3o  %2X  %s\n",
	       i, i, i/16, i%16, i, i, name[j]);
    }
}
