/*
  latin1.c.  Produce a table of ISO Latin Alphabet 1.
  F. da Cruz, Columbia University, 1991.
*/
char *name[] = {
   "No-break space",
   "Inverted exclamation",
   "Cent sign",
   "Pound sign",
   "Currency sign",
   "Yen sign",
   "Broken bar",
   "Paragraph sign",
   "Diaeresis",
   "Copyright sign",
   "Feminine ordinal",
   "Left angle quotation",
   "Not sign",
   "Soft hyphen",
   "Registered trade mark",
   "Macron",
   "Degree sign, ring above",
   "Plus-minus sign",
   "Superscript two",
   "Superscript three",
   "Acute accent",
   "Micro sign",
   "Pilcrow sign",
   "Middle dot",
   "Cedilla",
   "Superscript one",
   "Masculine ordinal",
   "Right angle quotation",
   "One quarter",
   "One half",
   "Three quarters",
   "Inverted question mark",
   "A grave",
   "A acute",
   "A circumflex",
   "A tilde",
   "A diaeresis",
   "A ring above",
   "A with E",
   "C Cedilla",
   "E grave",
   "E acute",
   "E circumflex",
   "E diaeresis",
   "I grave",
   "I acute",
   "I circumflex",
   "I diaeresis",
   "Icelandic Eth",
   "N tilde",
   "O grave",
   "O acute",
   "O circumflex",
   "O tilde",
   "O diaeresis",
   "Multiplication sign",
   "O oblique stroke",
   "U grave",
   "U acute",
   "U circumflex",
   "U diaeresis",
   "Y acute",
   "Icelandic Thorn",
   "German sharp s",
   "a grave",
   "a acute",
   "a circumflex",
   "a tilde",
   "a diaeresis",
   "a ring above",
   "a with e",
   "c cedilla",
   "e grave",
   "e acute",
   "e circumflex",
   "e diaeresis",
   "i grave",
   "i acute",
   "i circumflex",
   "i diaeresis",
   "Icelandic eth",
   "n tilde",
   "o grave",
   "o acute",
   "o circumflex",
   "o tilde",
   "o diaeresis",
   "Division sign",
   "o oblique stroke",
   "u grave",
   "u acute",
   "u circumflex",
   "u diaeresis",
   "y acute",
   "Icelandic thorn",
   "y diaeresis"
};


main() {
    int i, j;
    printf("ISO 8859-1 Latin Alphabet 1\n");
    printf("char dec col/row oct hex  description\n");
    for (i = 160; i < 256; i++) {
	j = i - 160;
	printf("[%c]  %3d  %02d/%02d  %3o  %2X  %s\n",
	       i, i, i/16, i%16, i, i, name[j]);
    }
}
