@part(latin,root="book")
@newpage()
@label(-latin)
@Modify<Plus,Size -0.2,script 0.1lines>
@subh<ISO 8859-1 Latin Alphabet 1>
@index<Character Sets>
@index<Latin-1>@index<ISO Latin Alphabet 1>

Table @ref<-l1tbl> shows the characters of ISO 8859-2 Latin Alphabet 1,
which is supported as both a transfer character-set and a file
character-set by C-Kermit.

The character names are taken from ISO Standard 8859-1, modified to show upper
or lower case typographically rather than spelling out UPPER CASE and LOWER
CASE for each letter.

@begin<table,invisible,above 0,below 1.5picas>
@caption<ISO Latin Alphabet 1>
@tag<-l1tbl>
@end<table>
@style(tableheadingwidth on,tablecontinuation open)
@definerowformat(l1topheading, boxtype vthinbox, columns=[column flushleft,
column combined, column combined, column combined, column combined,
column combined])
@definerowformat(l1entries, columns=[column center, column flushleft, 
column center, column center, column flushleft, column flushleft])
@definerowformat(l1headings, boxtype vthinbox, columns=[column center,
column flushleft, column flushleft,
column flushleft, column flushleft, column flushleft], boxtype hxbx)
@begin<format,tablecolumns=l1entries,size 9.5,spread 10pts,boxtype thinbox,
  use standardboxmargins,boxlm 5pts,boxrm 5pts>
@tableid(l1table)
@tableheading(immediate, rowformat l1topheading,
Line [@b<Table @ref(-l1tbl)@hsp(2ems)>ISO 8859-1 Latin Alphabet 1])
@tableheading{continued, rowformat l1topheading,
Line [@b<Table @ref(-l1tbl)@hsp(2ems)>ISO 8859-1 Latin Alphabet 1@~
(continued)]}
@tableheading(immediate, rowformat l1headings, continued,
Line [@i<Char>@\@i<Dec>@\@i<Row/Col>@\@i<Oct>@\@i<Hex>@\@i<Name>])

@\160@\10/00@\240@\A0@\No-break space

@act(!)@\161@\10/01@\241@\A1@\Inverted exclamation

@cent()@\162@\10/02@\242@\A2@\Cent sign

@sterling()@\163@\10/03@\243@\A3@\Pound sign

@currency()@\164@\10/04@\244@\A4@\Currency sign

@yen()@\165@\10/05@\245@\A5@\Yen sign

@vbar()@\166@\10/06@\246@\A6@\Broken bar

@prg()@\167@\10/07@\247@\A7@\Paragraph sign

@umlaut()@\168@\10/08@\250@\A8@\Diaeresis

@s(&)@\169@\10/09@\251@\A9@\Copyright sign

@fem()@\170@\10/10@\252@\AA@\Feminine ordinal

@gml()@\171@\10/11@\253@\AB@\Left angle quotation

@s(3)@\172@\10/12@\254@\AC@\Not sign

 @\173@\10/13@\255@\AD@\Soft hyphen

@s(%)@\174@\10/14@\256@\AE@\Registered trade mark

@macron()@\175@\10/15@\257@\AF@\Macron

@degree()@\176@\11/00@\260@\B0@\Degree sign, ring above

@s(p)@\177@\11/01@\261@\B1@\Plus-minus sign

@tiny(@+<2>)@\178@\11/02@\262@\B2@\Superscript two

@tiny(@+<3>)@\179@\11/03@\263@\B3@\Superscript three

@acute()@\180@\11/04@\264@\B4@\Acute accent

@g(m)@\181@\11/05@\265@\B5@\Micro sign

@pilcrow()@\182@\11/06@\266@\B6@\Pilcrow sign

@bullet()@\183@\11/07@\267@\B7@\Middle dot

@cedilla@\184@\11/08@\270@\B8@\Cedilla

@tiny(@+<1>)@\185@\11/09@\271@\B9@\Superscript one

@masc()@\186@\11/10@\272@\BA@\Masculine ordinal

@gmr()@\187@\11/11@\273@\BB@\Right angle quotation

@frac14()@\188@\11/12@\274@\BC@\One quarter

@frac12()@\189@\11/13@\275@\BD@\One half

@frac34()@\190@\11/14@\276@\BE@\Three quarters

@act(?)@\191@\11/15@\277@\BF@\Inverted question mark

@uagr()@\192@\12/00@\300@\C0@\A grave

@uaac()@\193@\12/01@\301@\C1@\A acute

@uacr()@\194@\12/02@\302@\C2@\A circumflex

@uatl()@\195@\12/03@\303@\C3@\A tilde

@uaum()@\196@\12/04@\304@\C4@\A diaeresis

@uawc()@\197@\12/05@\305@\C5@\A ring above

@uae()@\198@\12/06@\306@\C6@\A with E

@uccd()@\199@\12/07@\307@\C7@\C Cedilla

@uegr()@\200@\12/08@\310@\C8@\E grave

@ueac()@\201@\12/09@\311@\C9@\E acute

@uecr()@\202@\12/10@\312@\CA@\E circumflex

@ueum()@\203@\12/11@\313@\CB@\E diaeresis

@uigr()@\204@\12/12@\314@\CC@\I grave

@uiac()@\205@\12/13@\315@\CD@\I acute

@uicr()@\206@\12/14@\316@\CE@\I circumflex

@uium()@\207@\12/15@\317@\CF@\I diaeresis

@act()]@\208@\13/00@\320@\D0@\Icelandic Eth

@untl()@\209@\13/01@\321@\D1@\N tilde

@uogr()@\210@\13/02@\322@\D2@\O grave

@uoac()@\211@\13/03@\323@\D3@\O acute

@uocr()@\212@\13/04@\324@\D4@\O circumflex

@uotl()@\213@\13/05@\325@\D5@\O tilde

@uoum()@\214@\13/06@\326@\D6@\O diaeresis

@s(s)@\215@\13/07@\327@\D7@\Multiplication sign

@uows()@\216@\13/08@\330@\D8@\O oblique stroke

@uugr()@\217@\13/09@\331@\D9@\U grave

@uuac()@\218@\13/10@\332@\DA@\U acute

@uucr()@\219@\13/11@\333@\DB@\U circumflex

@uuum()@\220@\13/12@\334@\DC@\U diaeresis

@uyac()@\221@\13/13@\335@\DD@\Y acute

@act(^)@\222@\13/14@\336@\DE@\Icelandic Thorn

@ss()@\223@\13/15@\337@\DF@\German sharp s

@agr()@\224@\14/00@\340@\E0@\a grave

@aac()@\225@\14/01@\341@\E1@\a acute

@acr()@\226@\14/02@\342@\E2@\a circumflex

@atl()@\227@\14/03@\343@\E3@\a tilde

@aum()@\228@\14/04@\344@\E4@\a diaeresis

@awc()@\229@\14/05@\345@\E5@\a ring above

@ae()@\230@\14/06@\346@\E6@\a with e

@ccd()@\231@\14/07@\347@\E7@\c cedilla

@egr()@\232@\14/08@\350@\E8@\e grave

@eac()@\233@\14/09@\351@\E9@\e acute

@ecr()@\234@\14/10@\352@\EA@\e circumflex

@eum()@\235@\14/11@\353@\EB@\e diaeresis

@igr()@\236@\14/12@\354@\EC@\i grave

@iac()@\237@\14/13@\355@\ED@\i acute

@icr()@\238@\14/14@\356@\EE@\i circumflex

@ium()@\239@\14/15@\357@\EF@\i diaeresis

@act(})@\240@\15/00@\360@\F0@\Icelandic eth

@ntl()@\241@\15/01@\361@\F1@\n tilde

@ogr()@\242@\15/02@\362@\F2@\o grave

@oac()@\243@\15/03@\363@\F3@\o acute

@ocr()@\244@\15/04@\364@\F4@\o circumflex

@otl()@\245@\15/05@\365@\F5@\o tilde

@oum()@\246@\15/06@\366@\F6@\o diaeresis

@s(w)@\247@\15/07@\367@\F7@\Division sign

@ows()@\248@\15/08@\370@\F8@\o oblique stroke

@ugr()@\249@\15/09@\371@\F9@\u grave

@uac()@\250@\15/10@\372@\FA@\u acute

@ucr()@\251@\15/11@\373@\FB@\u circumflex

@uum()@\252@\15/12@\374@\FC@\u diaeresis

@yac()@\253@\15/13@\375@\FD@\y acute

@act(6)@\254@\15/14@\376@\FE@\Icelandic thorn

@yum()@\255@\15/15@\377@\FF@\y diaeresis

@end<format>

