/* ckotcp.c
 *
 * Dummy TCPIPDLL.DLL for C-Kermit for systems without TCP/IP
 *
 * Author:  Kai-Uwe Rommel <rommel@jonas.gold.muc.de>
 * Created: Thu Apr 22 1993
 */

#ifndef __32BIT__
#define _Far16
#define _Seg16
#endif
 
int _Far16 bswap() { return -1; }
int _Far16 connect() { return -1; }
void * _Seg16 _Far16 gethostbyname() { return 0; }
void * _Seg16 _Far16 getservbyname() { return 0; }
long _Far16 inet_addr() { return -1; }
void * _Seg16 _Far16 inet_ntoa() { return 0; }
int _Far16 ioctl() { return -1; }
int _Far16 recv() { return -1; }
int _Far16 select() { return -1; }
int _Far16 send() { return -1; }
int _Far16 setsockopt() { return -1; }
int _Far16 sock_init() { return -1; }
int _Far16 socket() { return -1; }
int _Far16 soclose() { return -1; }

/* end of ckotcp.c */
