# CKSKER.MAK,  Wed Jun 30 20:15:00 1993
#
CKVER= "5A(189)"
###########################################################################
#
#  Compile and Link variables:
#
#  $O is the extension (file type) for object files, normally o.
#  See MINIX entry for what to do if another filetype must be used.
#
O=.o
LNKFLAGS=-s
SHAREDLIB=
CC= cc
CC2= cc
#-DNOCCTRAP
#CFLAGS=-A -DDYNAMIC -DNODIAL -DNOSCRIPT -DDCMDBUF -DNOCSETS -DNOANSI \
# -Dmsleep=mnap
CFLAGS=-A -DDYNAMIC -DNODIAL -DNOSCRIPT -DNOCSETS -DNOANSI -Dmsleep=mnap
#
# Dependencies Section:
#
wermit:	ckcmai$(O) ckucmd$(O) ckuusr$(O) ckuus2$(O) ckuus3$(O) \
		ckuus4$(O) ckuus5$(O) ckuus6$(O) ckuus7$(O) \
		ckuusx$(O) ckuusy$(O) ckcpro$(O) ckcfns$(O) \
		ckcfn2$(O) ckcfn3$(O) ckuxla$(O) ckscon$(O) \
		ckstio$(O) cksfio$(O) ckudia$(O) ckuscr$(O) \
		ckcnet$(O) linkit
	$(CC2) $(LNKFLAGS) -o wermit ckcmai$(O) ckstio$(O) \
		cksfio$(O) ckcfns$(O) ckcfn2$(O) ckcfn3$(O) \
		ckuxla$(O) ckcpro$(O) ckucmd$(O) ckuus2$(O) \
		ckuus3$(O) ckuus4$(O) ckuus5$(O) ckuus6$(O) \
		ckuus7$(O) ckuusx$(O) ckuusy$(O) ckuusr$(O) \
		ckscon$(O) ckudia$(O) ckuscr$(O) ckcnet$(O)

ckstst.prg: ckstst$(O) cksfio$(O)
	$(CC2) -VCSD -o ckstst.prg ckstst.o cksfio.o

# If memory problems then
# use make -n -f cksker.mak cksker.dif | msh
cksker.dif:
	dobe -n "diff -c orig/%s . >>f:\cksker.dif" ck[cu]*.[ch]
	cp f:\cksker.dif .
	rm f:\cksker.dif

# If memory problems then
# use make -n -f cksker.mak cks189.zoo | msh
cks189.zoo:
	zoo ah cks189 *kermit.ttp cks*.c cksker.mak

# Make baby kermit.  No parser, debugging, etc.
baby:
	make -f cksker.mak "CFLAGS=-DDYNAMIC -DNODIAL -DNOSCRIPT -DNOCSETS \
	-DNOANSI -DNODEBUG -DNOICP -DNOSERVER -DNOTLOG -Dmsleep=mnap" wermit

ckcmai$(O): ckcmai.c ckcker.h ckcdeb.h ckcsym.h ckcasc.h ckcnet.h

ckcpro$(O): ckcpro.c ckcker.h ckcdeb.h ckcasc.h

ckcpro.c: ckcpro.w wart ckcdeb.h ckcasc.h ckcker.h
	.\wart ckcpro.w ckcpro.c

ckcfns$(O): ckcfns.c ckcker.h ckcdeb.h ckcsym.h ckcasc.h ckcxla.h \
		ckuxla.h

ckcfn2$(O): ckcfn2.c ckcker.h ckcdeb.h ckcsym.h ckcasc.h ckcxla.h ckuxla.h

ckcfn3$(O): ckcfn3.c ckcker.h ckcdeb.h ckcsym.h ckcasc.h ckcxla.h \
		ckuxla.h

ckuxla$(O): ckuxla.c ckcker.h ckcdeb.h ckcxla.h ckuxla.h

ckuusr$(O): ckuusr.c ckucmd.h ckcker.h ckuusr.h ckcdeb.h ckcxla.h ckuxla.h \
		ckcasc.h ckcnet.h

ckuus2$(O): ckuus2.c ckucmd.h ckcker.h ckuusr.h ckcdeb.h ckcxla.h ckuxla.h \
		ckcasc.h

ckuus3$(O): ckuus3.c ckucmd.h ckcker.h ckuusr.h ckcdeb.h ckcxla.h ckuxla.h \
		ckcasc.h ckcnet.h

ckuus4$(O): ckuus4.c ckucmd.h ckcker.h ckuusr.h ckcdeb.h ckcxla.h ckuxla.h \
		ckcasc.h ckcnet.h

ckuus5$(O): ckuus5.c ckucmd.h ckcker.h ckuusr.h ckcdeb.h ckcasc.h

ckuus6$(O): ckuus6.c ckucmd.h ckcker.h ckuusr.h ckcdeb.h ckcasc.h

ckuus7$(O): ckuus7.c ckucmd.h ckcker.h ckuusr.h ckcdeb.h ckcxla.h ckuxla.h \
		ckcasc.h ckcnet.h

ckuusx$(O): ckuusx.c  ckcker.h ckuusr.h ckcdeb.h ckcasc.h

ckuusy$(O): ckuusy.c  ckcker.h ckcdeb.h ckcasc.h

ckucmd$(O): ckucmd.c ckcasc.h ckucmd.h ckcdeb.h

cksfio$(O): cksfio.c ckcdeb.h ckuver.h

ckstio$(O): ckstio.c ckcdeb.h ckcnet.h ckuver.h

ckscon$(O): ckscon.c ckcker.h ckcdeb.h ckcasc.h ckcnet.h

ckcnet$(O): ckcnet.c ckcdeb.h ckcker.h ckcnet.h

wart: ckwart$(O)
	$(CC) $(LNKFLAGS) -o wart ckwart$(O) $(LIBS)

ckcmdb$(O): ckcmdb.c ckcdeb.h

ckwart$(O): ckwart.c

ckudia$(O): ckudia.c ckcker.h ckcdeb.h ckucmd.h ckcasc.h

ckuscr$(O): ckuscr.c ckcker.h ckcdeb.h ckcasc.h
