OS4000  does  not support LOGIN/LOGOUT from the micro Kermit.  However,
it is possible for a System Manager to arrange a Kermit login option so
that a user only needs to connect once.

What I have done is the following:

add the lines:

        OPTION KERMIT
              MODE NODP
              JCL SYS.INITKERM
              PROF SYSFILES.NDPUSR
              CONTEXT DIRECTRY 

to  the  global  declarations  in the ACCOUNTS source file (if it suits
your system  better,  you  could  just  as  well  have  MODE  NORM  and
SYSFILES.USER).  Then set up SYS.INITKERM as:

        // INITJCL FOR AN AUTO-KERMIT USER.
         
        // RESTRICTED USER PROFORMAE
        // Note that for 5.5 ( COMM v. 930 ), if MODE='NODP', proformas must be
        //  this way round.
        PROFORMA KERMIT  (T=-1 C=-1) IN       = STREAM 1 (*) -
                          OUT      = STREAM 2 (*/NEW) -
                          WITH     = STREAM 5 (SINK)
         
        PROFORMA CONTROL  IN       = STREAM 1 (%C) -
                          OUT      = STREAM 2 (*/NEW)
         
        //ENABLE BACKSPACE DELETES
        CONTROL IN=%H+
        ?XC?H08
        +
         
        //INFINITE FILE SIZE
        DEFAULT /I
         
        END
         
        SAY
        SAY Use GET <GEC filename> or SEND <local filename>. Remember to type
        SAY FINISH when you have finished.
        SAY
        KERMIT WITH %H;
        SERVER
        EXIT
        ;
        IF ERROR THEN CONTINUE
        LOGOUT


With  this  set-up, all the user has to do is CONNECT and log in to the
GEC as UUUUUU AAAAAA KERMIT.  This starts GEC Kermit up in Server mode.
Then  the  user can escape to his/her local Kermit and SEND and GET the
required files.  When (s)he types FINISH, (s)he gets  logged  out  from
the GEC.
