#
#     A Makefile for Kermit under RTE-6 or RTE-A
#
includes == kcmnds.ftni kconcw.ftni kercmd.ftni kercnf.ftni kercom.ftni 
includes == &includes kerdbg.ftni kerfil.ftni kersta.ftni  
 
kermit.rel: kermit.ftn &includes
 =ftn7x kermit,,-,,s
 
\$k6subs.lib: k6subs.ftn &includes
 =ftn7x k6subs,,-,,s
 =lindx k6subs.rel \$k6subs.lib
 =cix in pu k6subs.rel
 
\$kasubs.lib: kasubs.ftn &includes
 =ftn7x kasubs,,-,,s
 =lindx kasubs.rel \$kasubs.lib
 =cix in pu kasubs.rel
 
kermit.run: kermit.rel \$kasubs.lib \$k6subs.lib kermit.lod
 >link kermit.lod
 
# 
#     In the following, we don't care if an error occurs in the
#     initial renaming - this step is only to recover the old
#     help file (it is, after all, better than nothing) if the
#     final rename fails.
# 
kermit.hlp: kermit.text
 cix in rn .hlp .ohlp             # in case we can't rebuild it
 cix in pu .hlp                   # be sure KERMIT.HLP no longer exists
 genix kermit.text,,kermit.hlp    # this should rebuild it, but cannot check
 =dl kermit.hlp,,0                # does it exist?
  ?cix in rn .ohlp .hlp           # no - bring the old one back
  ?touch kermit.hlp               #      but show it as changed
 cix in pu kermit.ohlp            # else remove our insurance
 
