.TH VMSBU l "20 February 1987"
.SH NAME
vmsbu \- vms backup extractor
.SH SYNOPSIS
.B vmsbu
[\ \fB\-f\ \fItapefile\fR\ ]
[\ \fB\-t\fR\ ]
[\ \fIfilename1\fR\ ]
[\ \fIfilename2\fR\ ...\ ]
.SH DESCRIPTION
.I vmsbu
extracts files from a VMS backup tape
.SH OPTIONS
.TP
.B \-f
Use the next argument as the name of the \fItapefile\fP instead
of /dev/rmt0m
.TP
.B \-t
List the contents of the tape.  No files are extracted and
\fIfilename1, filename2 \fP... are ignored.
.IP
If no filenames are specified, the entire tape is retored.  If one
or more of \fIfilename1, filename2\fP, ... are specified, only these
files are extracted.  The filenames cannot contain wildcards and
must be appear exactly as they are on the tape.  This usually means
that filenames must be enclosed in double quotes, as vms files names contain
special characters (i.e., ";"), and that the filenames must appear in CAPS.
.SH EXAMPLE
vmsbu -f /dev/rmt0h "[MRC.DATA]RABBITS.DAT;3"
.SH AUTHOR
.DS
John Douglas CAREY.  Net-addess: john%monu1.oz@seismo.ARPA
.DE
.DS
modified - Doug Shearer Feb 87
.DE
.SH BUGS
If a specified file does not appear on the tape, no error message is 
generated.
.LP
Multivolume backup tapes are not supported.
.LP
VMS backup will write duplicate blocks when soft errors occur on a tape.  It
is not clear whether
.I vmsbu
processes these correctly.
