.TH CUTAPE 1 "17 May 1987"
.UC 4
.SH NAME
cutape \- write an ibm os ebcdic or ansi ascii standard labelled tape
.SH SYNOPSIS
.B cutape
[
.B \-v volume label
] [
.B \-o owner
] [
.B \-b block length
] [
.B \-l record length
] [ 
.B \-t type
] [ 
.B \-f tape device
] filename ... 

.SH DESCRIPTION
.B cutape
writes an IBM OS Standard Labeled Format VB EBCDIC tape or ANSI Level-3 Format D ASCII tape.  The
.B \-t
flag is used to specify the format of the tape, "a" for ANSI, "e" for EBCDIC
.PP
Command line options:
.IP \fB\-v\fP 5
volume label consists of up to 6 characters,
it is "KERMIT" by default.
.IP \fB\-o\fP 5
owner of the tape
.IP \fB\-b\fP 5
block size, 8192 by default
.IP \fB\-l\fP 5
maximum record length, 300 by default
.IP \fB\-t\fP 5
type of tape, 'a' for ANSI, or 'e' for EBCDIC.  'e' by default.
.IP \fB\-f\fP 5

tape device, by default the system's default tape drive, e.g. /dev/rmt12.
.SH "SEE ALSO"
ansitar(1)
.SH AUTHORS
Grace Lee, Jeff Damens, Frank da Cruz, Columbia University Center for
Computing Activities, New York, NY  10027.
